#<profile4xi profile = "31"/>
#<program4xi program = "build2scope4xi.py">
#<abstract4xi abstract = "builds exe files for defined programs in scope4xi folders"/>
#<refer4xi reference = "Studio4Xi"/>
#<note4xi note = "rewrites existing exe files"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'build2scope4xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
# from distutils.core import setup
import marshal 
import os,sys,string
# import py2exe
import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI 
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from print4xi import print4xi
from print4xi import Print4Xi 
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global count2skipped
global count2found
global count2total
global kb2build                              # knowledgebase for building
global path2read4xi                          # path for input source programs
global path2write4xi                         # path for output source programs
global PickleKB4Xi
global profile2build                         # extension for files
global t2xi 
global trace_object_count
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
count2skipped = 0
count2found = 0
count2total = 0                                                                                            
kb2build = {}                                # programs to be builded                                
kb2build[1]  = 'apu2sampler4xi5test.cpython-32.pyc'
kb2build[2]  = 'bpu2sampler4xi5test.cpython-32.pyc'
kb2build[3]  = 'cpu2sampler4xi5test.cpython-32.pyc'
kb2build[4]  = 'dpu2sampler4xi5test.cpython-32.pyc'
kb2build[5]  = 'epu2sampler4xi5test.cpython-32.pyc'
kb2build[6]  = 'fpu2sampler4xi5test.cpython-32.pyc'
kb2build[7]  = 'gpu2sampler4xi5test.cpython-32.pyc'
kb2build[8]  = 'hpu2sampler4xi5test.cpython-32.pyc'
kb2build[9]  = 'ipu2sampler4xi5test.cpython-32.pyc'
kb2build[10] = 'jpu2sampler4xi5test.cpython-32.pyc'
kb2build[11] = 'kpu2sampler4xi5test.cpython-32.pyc'
kb2build[12] = 'lpu2sampler4xi5test.cpython-32.pyc'
kb2build[13] = 'mpu2sampler4xi5test.cpython-32.pyc'
kb2build[14] = 'npu2sampler4xi5test.cpython-32.pyc'
kb2build[15] = 'opu2sampler4xi5test.cpython-32.pyc'
kb2build[16] = 'ppu2sampler4xi5test.cpython-32.pyc'
kb2build[17] = 'qpu2sampler4xi5test.cpython-32.pyc'
kb2build[18] = 'rpu2sampler4xi5test.cpython-32.pyc'
kb2build[19] = 'spu2sampler4xi5test.cpython-32.pyc'
kb2build[20] = 'tpu2sampler4xi5test.cpython-32.pyc'
kb2build[21] = 'upu2sampler4xi5test.cpython-32.pyc'
kb2build[22] = 'vpu2sampler4xi5test.cpython-32.pyc'
kb2build[23] = 'wpu2sampler4xi5test.cpython-32.pyc'
kb2build[24] = 'xpu2sampler4xi5test.cpython-32.pyc'
kb2build[25] = 'ypu2sampler4xi5test.cpython-32.pyc'
kb2build[26] = 'zpu2sampler4xi5test.cpython-32.pyc'

kb2build[27] = 'apu2buffer4xi5test.cpython-32.pyc'
kb2build[28] = 'bpu2buffer4xi5test.cpython-32.pyc'
kb2build[29] = 'cpu2buffer4xi5test.cpython-32.pyc'
kb2build[30] = 'dpu2buffer4xi5test.cpython-32.pyc'
kb2build[31] = 'epu2buffer4xi5test.cpython-32.pyc'
kb2build[32] = 'fpu2buffer4xi5test.cpython-32.pyc'
kb2build[33] = 'gpu2buffer4xi5test.cpython-32.pyc'
kb2build[34] = 'hpu2buffer4xi5test.cpython-32.pyc'
kb2build[35] = 'ipu2buffer4xi5test.cpython-32.pyc'
kb2build[36] = 'jpu2buffer4xi5test.cpython-32.pyc'
kb2build[37] = 'kpu2buffer4xi5test.cpython-32.pyc'
kb2build[38] = 'lpu2buffer4xi5test.cpython-32.pyc'
kb2build[39] = 'mpu2buffer4xi5test.cpython-32.pyc'
kb2build[40] = 'npu2buffer4xi5test.cpython-32.pyc'
kb2build[41] = 'opu2buffer4xi5test.cpython-32.pyc'
kb2build[42] = 'ppu2buffer4xi5test.cpython-32.pyc'
kb2build[43] = 'qpu2buffer4xi5test.cpython-32.pyc'
kb2build[44] = 'rpu2buffer4xi5test.cpython-32.pyc'
kb2build[45] = 'spu2buffer4xi5test.cpython-32.pyc'
kb2build[46] = 'tpu2buffer4xi5test.cpython-32.pyc'
kb2build[47] = 'upu2buffer4xi5test.cpython-32.pyc'
kb2build[48] = 'vpu2buffer4xi5test.cpython-32.pyc'
kb2build[49] = 'wpu2buffer4xi5test.cpython-32.pyc'
kb2build[50] = 'xpu2buffer4xi5test.cpython-32.pyc'
kb2build[51] = 'ypu2buffer4xi5test.cpython-32.pyc'
kb2build[52] = 'zpu2buffer4xi5test.cpython-32.pyc'

kb2build[53] = 'apu2commandqueue4xi5test.cpython-32.pyc'
kb2build[54] = 'bpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[55] = 'cpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[56] = 'dpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[57] = 'epu2commandqueue4xi5test.cpython-32.pyc'
kb2build[58] = 'fpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[59] = 'gpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[60] = 'hpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[61] = 'ipu2commandqueue4xi5test.cpython-32.pyc'
kb2build[62] = 'jpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[63] = 'kpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[64] = 'lpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[65] = 'mpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[66] = 'npu2commandqueue4xi5test.cpython-32.pyc'
kb2build[67] = 'opu2commandqueue4xi5test.cpython-32.pyc'
kb2build[68] = 'ppu2commandqueue4xi5test.cpython-32.pyc'
kb2build[69] = 'qpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[70] = 'rpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[71] = 'spu2commandqueue4xi5test.cpython-32.pyc'
kb2build[72] = 'tpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[73] = 'upu2commandqueue4xi5test.cpython-32.pyc'
kb2build[74] = 'vpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[75] = 'wpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[76] = 'xpu2commandqueue4xi5test.cpython-32.pyc'
kb2build[77] = 'ypu2commandqueue4xi5test.cpython-32.pyc'
kb2build[78] = 'zpu2commandqueue4xi5test.cpython-32.pyc'

kb2build[79]  = 'apu2context4xi5test.cpython-32.pyc'
kb2build[80]  = 'bpu2context4xi5test.cpython-32.pyc'
kb2build[81]  = 'cpu2context4xi5test.cpython-32.pyc'
kb2build[82]  = 'dpu2context4xi5test.cpython-32.pyc'
kb2build[83]  = 'epu2context4xi5test.cpython-32.pyc'
kb2build[84]  = 'fpu2context4xi5test.cpython-32.pyc'
kb2build[85]  = 'gpu2context4xi5test.cpython-32.pyc'
kb2build[86]  = 'hpu2context4xi5test.cpython-32.pyc'
kb2build[87]  = 'ipu2context4xi5test.cpython-32.pyc'
kb2build[88]  = 'jpu2context4xi5test.cpython-32.pyc'
kb2build[89]  = 'kpu2context4xi5test.cpython-32.pyc'
kb2build[90]  = 'lpu2context4xi5test.cpython-32.pyc'
kb2build[91]  = 'mpu2context4xi5test.cpython-32.pyc'
kb2build[92]  = 'npu2context4xi5test.cpython-32.pyc'
kb2build[93]  = 'opu2context4xi5test.cpython-32.pyc'
kb2build[94]  = 'ppu2context4xi5test.cpython-32.pyc'
kb2build[95]  = 'qpu2context4xi5test.cpython-32.pyc'
kb2build[96]  = 'rpu2context4xi5test.cpython-32.pyc'
kb2build[97]  = 'spu2context4xi5test.cpython-32.pyc'
kb2build[98]  = 'tpu2context4xi5test.cpython-32.pyc'
kb2build[99]  = 'upu2context4xi5test.cpython-32.pyc'
kb2build[100] = 'vpu2context4xi5test.cpython-32.pyc'
kb2build[101] = 'wpu2context4xi5test.cpython-32.pyc'
kb2build[102] = 'xpu2context4xi5test.cpython-32.pyc'
kb2build[103] = 'ypu2context4xi5test.cpython-32.pyc'
kb2build[104] = 'zpu2context4xi5test.cpython-32.pyc'

kb2build[105]  = 'apu2device4xi5test.cpython-32.pyc'
kb2build[106]  = 'bpu2device4xi5test.cpython-32.pyc'
kb2build[107]  = 'cpu2device4xi5test.cpython-32.pyc'
kb2build[108]  = 'dpu2device4xi5test.cpython-32.pyc'
kb2build[109]  = 'epu2device4xi5test.cpython-32.pyc'
kb2build[110]  = 'fpu2device4xi5test.cpython-32.pyc'
kb2build[111]  = 'gpu2device4xi5test.cpython-32.pyc'
kb2build[112]  = 'hpu2device4xi5test.cpython-32.pyc'
kb2build[113]  = 'ipu2device4xi5test.cpython-32.pyc'
kb2build[114]  = 'jpu2device4xi5test.cpython-32.pyc'
kb2build[115]  = 'kpu2device4xi5test.cpython-32.pyc'
kb2build[116]  = 'lpu2device4xi5test.cpython-32.pyc'
kb2build[117]  = 'mpu2device4xi5test.cpython-32.pyc'
kb2build[118]  = 'npu2device4xi5test.cpython-32.pyc'
kb2build[119]  = 'opu2device4xi5test.cpython-32.pyc'
kb2build[120]  = 'ppu2device4xi5test.cpython-32.pyc'
kb2build[121]  = 'qpu2device4xi5test.cpython-32.pyc'
kb2build[122]  = 'rpu2device4xi5test.cpython-32.pyc'
kb2build[123]  = 'spu2device4xi5test.cpython-32.pyc'
kb2build[124]  = 'tpu2device4xi5test.cpython-32.pyc'
kb2build[125]  = 'upu2device4xi5test.cpython-32.pyc'
kb2build[126]  = 'vpu2device4xi5test.cpython-32.pyc'
kb2build[127]  = 'wpu2device4xi5test.cpython-32.pyc'
kb2build[128]  = 'xpu2device4xi5test.cpython-32.pyc'
kb2build[129]  = 'ypu2device4xi5test.cpython-32.pyc'
kb2build[130]  = 'zpu2device4xi5test.cpython-32.pyc'

kb2build[131]  = 'apu2event4xi5test.cpython-32.pyc'
kb2build[132]  = 'bpu2event4xi5test.cpython-32.pyc'
kb2build[133]  = 'cpu2event4xi5test.cpython-32.pyc'
kb2build[134]  = 'dpu2event4xi5test.cpython-32.pyc'
kb2build[135]  = 'epu2event4xi5test.cpython-32.pyc'
kb2build[136]  = 'fpu2event4xi5test.cpython-32.pyc'
kb2build[137]  = 'gpu2event4xi5test.cpython-32.pyc'
kb2build[138]  = 'hpu2event4xi5test.cpython-32.pyc'
kb2build[139]  = 'ipu2event4xi5test.cpython-32.pyc'
kb2build[140]  = 'jpu2event4xi5test.cpython-32.pyc'
kb2build[141]  = 'kpu2event4xi5test.cpython-32.pyc'
kb2build[142]  = 'lpu2event4xi5test.cpython-32.pyc'
kb2build[143]  = 'mpu2event4xi5test.cpython-32.pyc'
kb2build[144]  = 'npu2event4xi5test.cpython-32.pyc'
kb2build[145]  = 'opu2event4xi5test.cpython-32.pyc'
kb2build[146]  = 'ppu2event4xi5test.cpython-32.pyc'
kb2build[147]  = 'qpu2event4xi5test.cpython-32.pyc'
kb2build[148]  = 'rpu2event4xi5test.cpython-32.pyc'
kb2build[149]  = 'spu2event4xi5test.cpython-32.pyc'
kb2build[150]  = 'tpu2event4xi5test.cpython-32.pyc'
kb2build[151]  = 'upu2event4xi5test.cpython-32.pyc'
kb2build[152]  = 'vpu2event4xi5test.cpython-32.pyc'
kb2build[153]  = 'wpu2event4xi5test.cpython-32.pyc'
kb2build[154]  = 'xpu2event4xi5test.cpython-32.pyc'
kb2build[155]  = 'ypu2event4xi5test.cpython-32.pyc'
kb2build[156]  = 'zpu2event4xi5test.cpython-32.pyc'

kb2build[157]  = 'apu2image4xi5test.cpython-32.pyc'
kb2build[158]  = 'bpu2image4xi5test.cpython-32.pyc'
kb2build[159]  = 'cpu2image4xi5test.cpython-32.pyc'
kb2build[160]  = 'dpu2image4xi5test.cpython-32.pyc'
kb2build[161]  = 'epu2image4xi5test.cpython-32.pyc'
kb2build[162]  = 'fpu2image4xi5test.cpython-32.pyc'
kb2build[163]  = 'gpu2image4xi5test.cpython-32.pyc'
kb2build[164]  = 'hpu2image4xi5test.cpython-32.pyc'
kb2build[165]  = 'ipu2image4xi5test.cpython-32.pyc'
kb2build[166]  = 'jpu2image4xi5test.cpython-32.pyc'
kb2build[167]  = 'kpu2image4xi5test.cpython-32.pyc'
kb2build[168]  = 'lpu2image4xi5test.cpython-32.pyc'
kb2build[169]  = 'mpu2image4xi5test.cpython-32.pyc'
kb2build[170]  = 'npu2image4xi5test.cpython-32.pyc'
kb2build[171]  = 'opu2image4xi5test.cpython-32.pyc'
kb2build[172]  = 'ppu2image4xi5test.cpython-32.pyc'
kb2build[173]  = 'qpu2image4xi5test.cpython-32.pyc'
kb2build[174]  = 'rpu2image4xi5test.cpython-32.pyc'
kb2build[175]  = 'spu2image4xi5test.cpython-32.pyc'
kb2build[176]  = 'tpu2image4xi5test.cpython-32.pyc'
kb2build[177]  = 'upu2image4xi5test.cpython-32.pyc'
kb2build[178] = 'vpu2image4xi5test.cpython-32.pyc'
kb2build[179] = 'wpu2image4xi5test.cpython-32.pyc'
kb2build[180] = 'xpu2image4xi5test.cpython-32.pyc'
kb2build[181] = 'ypu2image4xi5test.cpython-32.pyc'
kb2build[182] = 'zpu2image4xi5test.cpython-32.pyc'

kb2build[183]  = 'apu2program4xi5test.cpython-32.pyc'
kb2build[184]  = 'bpu2program4xi5test.cpython-32.pyc'
kb2build[185]  = 'cpu2program4xi5test.cpython-32.pyc'
kb2build[186]  = 'dpu2program4xi5test.cpython-32.pyc'
kb2build[187]  = 'epu2program4xi5test.cpython-32.pyc'
kb2build[188]  = 'fpu2program4xi5test.cpython-32.pyc'
kb2build[189]  = 'gpu2program4xi5test.cpython-32.pyc'
kb2build[190]  = 'hpu2program4xi5test.cpython-32.pyc'
kb2build[191]  = 'ipu2program4xi5test.cpython-32.pyc'
kb2build[192]  = 'jpu2program4xi5test.cpython-32.pyc'
kb2build[193]  = 'kpu2program4xi5test.cpython-32.pyc'
kb2build[194]  = 'lpu2program4xi5test.cpython-32.pyc'
kb2build[195]  = 'mpu2program4xi5test.cpython-32.pyc'
kb2build[196]  = 'npu2program4xi5test.cpython-32.pyc'
kb2build[197]  = 'opu2program4xi5test.cpython-32.pyc'
kb2build[198]  = 'ppu2program4xi5test.cpython-32.pyc'
kb2build[199]  = 'qpu2program4xi5test.cpython-32.pyc'
kb2build[200]  = 'rpu2program4xi5test.cpython-32.pyc'
kb2build[201]  = 'spu2program4xi5test.cpython-32.pyc'
kb2build[202]  = 'tpu2program4xi5test.cpython-32.pyc'
kb2build[203]  = 'upu2program4xi5test.cpython-32.pyc'
kb2build[204] = 'vpu2program4xi5test.cpython-32.pyc'
kb2build[205] = 'wpu2program4xi5test.cpython-32.pyc'
kb2build[206] = 'xpu2program4xi5test.cpython-32.pyc'
kb2build[207] = 'ypu2program4xi5test.cpython-32.pyc'
kb2build[208] = 'zpu2program4xi5test.cpython-32.pyc'

kb2build[209]  = 'apu3image4xi5test.cpython-32.pyc'
kb2build[210]  = 'bpu3image4xi5test.cpython-32.pyc'
kb2build[211]  = 'cpu3image4xi5test.cpython-32.pyc'
kb2build[212]  = 'dpu3image4xi5test.cpython-32.pyc'
kb2build[213]  = 'epu3image4xi5test.cpython-32.pyc'
kb2build[214]  = 'fpu3image4xi5test.cpython-32.pyc'
kb2build[215]  = 'gpu3image4xi5test.cpython-32.pyc'
kb2build[216]  = 'hpu3image4xi5test.cpython-32.pyc'
kb2build[217]  = 'ipu3image4xi5test.cpython-32.pyc'
kb2build[218]  = 'jpu3image4xi5test.cpython-32.pyc'
kb2build[219]  = 'kpu3image4xi5test.cpython-32.pyc'
kb2build[220]  = 'lpu3image4xi5test.cpython-32.pyc'
kb2build[221]  = 'mpu3image4xi5test.cpython-32.pyc'
kb2build[222]  = 'npu3image4xi5test.cpython-32.pyc'
kb2build[223]  = 'opu3image4xi5test.cpython-32.pyc'
kb2build[224]  = 'ppu3image4xi5test.cpython-32.pyc'
kb2build[225]  = 'qpu3image4xi5test.cpython-32.pyc'
kb2build[226]  = 'rpu3image4xi5test.cpython-32.pyc'
kb2build[227]  = 'spu3image4xi5test.cpython-32.pyc'
kb2build[228]  = 'tpu3image4xi5test.cpython-32.pyc'
kb2build[229]  = 'upu3image4xi5test.cpython-32.pyc'
kb2build[230]  = 'vpu3image4xi5test.cpython-32.pyc'
kb2build[231]  = 'wpu3image4xi5test.cpython-32.pyc'
kb2build[232]  = 'xpu3image4xi5test.cpython-32.pyc'
kb2build[233]  = 'ypu3image4xi5test.cpython-32.pyc'
kb2build[234]  = 'zpu3image4xi5test.cpython-32.pyc'

path2read4xi   = VersionKB4Xi['py2lib4scope']  # defines folder to be walked with all its subfolders
path2write4xi  = VersionKB4Xi['py2lib4scope']  # defines folder to save exe files

PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "
profile2build = '.pyc'                       # Python programs to be builded
                                             # Extensions: '.txt'= text '.py'=Python, '.cpp'=C++, '.hpp'=headers, '.c'=C

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4fecth" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4fecth():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 1A/33) OF SET2TRACE4FECTH - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 1B/33) OF SET2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4FECTH - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4FECTH - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4build" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4build():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 1A/33) of DENY2TRACE4FECTH: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 1B/33) OF DENY2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 2A/33) OF DENY2TRACE4FECTH - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 2B/33) OF DENY2TRACE4FECTH - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 2C/33) OF DENY2TRACE4FECTH - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 2D/33) OF DENY2TRACE4FECTH - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 2Z/33) OF DENY2TRACE4FECTH *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 2E/33) OF DENY2TRACE4FECTH - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 2F/33) OF DENY2TRACE4FECTH - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 33/33) OF SET2TRACE4FECTH - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 1A/33) OF TAILOR2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'build2scope4xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 2A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 33/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #04:16:46 10/17/11 Pacific Daylight Time 

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
#   print XML trace
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):

    class2print  = "build2scope4xi"
    method2print = "build2scope4xi" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-build2scope.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4apu.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/multiprocessing4apu.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing build2scope4xi.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">build2scope4xi sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-build2scope.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4apu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4apu.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for build2scope4xi.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-build2scope.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4apu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4apu.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for build2scope4xi.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of build2scope4xi.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2scope4xi" usage = "
#   builds exe files for defined programs into scope4xi folders
#"> 
# -------------------------------------------------------------------------------------------------
def build2scope4xi(program2explore):
    global count2skipped
    global count2found
    global count2total
    global kb2build                              # knowledgebase for building    
    global path2read4xi                          # path for input source programs
    global path2write4xi                         # path for output source programs
    global profile2build                         # extension for files

    global t2xi
    global trace_object_count    
    
    class2print  = "build2scope4xi"
    method2print = "build2scope4xi" 
 
    message2print = "{(Step 0A/33) using" + "; t2xi-using-by-build2scope4xi: " + str(t2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)         
    # <print4xi.Print4Xi object at 0x0000000003715080>
    message2print = "{(Step 1/8) got" + "; program2explore-got-by-build2scope4xi: " + str(program2explore)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #  ..//..//..//..//scope4xi//041721//zap//lib//a//__pycache__\apu2buffer4xi.cpython-32.pyc
               
    # ---------------------------------------------------------------------------------------------
    # SPLIT PROGRAM NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2program=os.path.splitext(program2explore)
    
    if name2program[1] == profile2build:          
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF FETCH2SCOPE4XI - COMPILED PYTHON PROGRAM
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 1A/33) analyzing" + "; program2explore-analyzing-by-build2scope4xi: " + str(program2explore) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # ..//..//..//..//scope4xi//041721//zap//lib//a//__pycache__\apu2buffer4xi.cpython-32.pyc
        
        path2input = name2program[0] + profile2build 
        message2print = "{(Step 1B/33) set" + "; path2input-set-by-build2scope4xi to: " + str(path2input)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # ..//..//..//..//scope4xi//041721//zap//lib//a//__pycache__\apu2buffer4xi.cpython-32.pyc

        # -----------------------------------------------------------------------------------------
        # (Step 2/33) OF FETCH2SCOPE4XI - CHECKING WHETHER EXE FILE MUST BE BUILT
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2A/33) analyzing" + "; path2input-analyzing-by-build2scope4xi: " + str(path2input) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # ..//..//..//..//scope4xi//041721//zap//lib//a//__pycache__\apu2buffer4xi.cpython-32.pyc
        
        keys2build = kb2build.keys()
        ack2match = False
        for key2fecth in keys2build:                                                                                # 1 ...
            string2search = kb2build[key2fecth]                                                                     # apu2sampler4xi5test.cpython-32.pyc ...
            index2search=str.find(path2input,string2search)                                                         # e://scope4xi//041721//zap//lib//a//__pycache__//apu2sampler4xi5test.cpython-32.pyc
            if index2search == -1:                                         
                pass                                                                                                # not ordered to be builded
            else:
                index2end=str.find(path2input,"cpython-32.pyc")  
                path2write4program = path2input[:index2end] + 'exe'                                                 # e://scope4xi//041721//zap//lib//a//__pycache__//apu2sampler4xi5test.exe    
                ack2match = True
                    
        if ack2match is True:
            message2print = "{(Step 2B/33) decided" + "; program-to-read-decided-by-build2scope4xi: " + str(path2input) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)        
            # ..//..//..//..//scope4xi//041721//zap//lib//a//__pycache__\apu2sampler4xi5test.cpython-32.pyc

            message2print = "{(Step 2C/33) decided" + "; program-to-write-decided-by-build2scope4xi: " + str(path2write4program) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                    
            #  ..//..//..//..//scope4xi//041721//zap//lib//a//__pycache__\apu2sampler4xi5test.exe

                          
            count2found = count2found + 1
            count2total = count2total + 1
            
            file2input = None
            try:
                # -----------------------------------------------------------------------------------------
                # (Step 3/33) OF FETCH2SCOPE4XI - OPEN INPUT
                # -----------------------------------------------------------------------------------------
                file2input = open(path2input,'rb')
                message2print = "{(Step 3A/33) opened" + "; file2input-opened-by-build2scope4xi: " + str(file2input) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)     
                # <_io.BufferedReader name='..//..//..//..//scope4xi//041721//zap//lib//a//__pycache__\\apu2sampler4xi5test.cpython-32.pyc'>
                
                file2process = file2input.read()
                message2print = "{(Step 3B/33) read" + "; file2input-read-by-build2scope4xi: " + str(file2input) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)     
                # <_io.BufferedReader name='..//..//..//..//scope4xi//041721//zap//lib//a//__pycache__\\apu2sampler4xi5test.cpython-32.pyc'>

                message2print = "{(Step 3C/33) got" + "; lenght2process-got-by-build2scope4xi: " + str(len(file2process)) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)     
                # 29543                 
                                
                file2output  = None
                file2execute = None
                try:
                    
                    try:
                        file2execute = marshal.loads(file2process[8:]) 
                        message2print = "{(Step 3D/33) set" + "; lenght2execute-set-by-build2scope4xi to: " + str(len(file2execute)) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        # 
                        
                        file2output = open(path2write4program,'wb') # open only when you are sure operations will succeed !
                        message2print = "{(Step 3C/33) opened" + "; file2output-opened-by-build2scope4xi: " + str(file2output) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)              
                        # <_io.BufferedWriter name='..//..//..//..//scope4xi//041721//zap//lib//a//__pycache__\\apu2sampler4xi5test.exe'>;

                        file2output.write(file2execute)
                        message2print = "{(Step 3E/33) wrote" + "; file2output-wrote-by-build2scope4xi: " + str(file2output) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #
                        
                        file2output.close()
                        message2print = "{(Step 3F/33) closed" + "; file2output-closed-by-build2scope4xi: " + str(file2output) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
                        #      
                        
                    except:
                        message2print = "{(Step 3Z1/33) failed" + "; marshal-failed-by-build2scope4xi: " + str(file2execute) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)     
                        # <code object <module> at 0x0000000003048C68, file "E:\Scope4xi\041721\zap\lib\a\apu2sampler4xi5test.py", line 14>                        
                        # Python 3.2 bug! 
                        
                except:
                    message2print = "{(Step 3Z2/33) failed" + "; file2output-failed-by-build2scope4xi: " + str(file2output) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    # 
                 
                # message2print = "{(Step 4A/33) trying" + "; setup-trying-by-build2scope4xi: " + "; time: " + time4xi() + "}"
                # print4xi(class2print, method2print, message2print)     
                #                             
                # try:    
                    # setup(console=[path2input]) 
                    # message2print = "{(Step 4BF/33) performed" + "; setup-performed-by-build2scope4xi: " + str(performed) + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)
                    # 
                # except:
                    # message2print = "{(Step 3Z3/33) failed" + "; setup-failed-by-build2scope4xi: " + "; time: " + time4xi() + "}"
                    # print4xi(class2print, method2print, message2print)     
                    #                       
             
                file2input.close()
                message2print = "{(Step 3G/33) closed" + "; file2input-closed-by-build2scope4xi: " + str(file2input) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)           
                # <_io.BufferedReader name='..//..//..//..//scope4xi//041721//zap//lib//a//__pycache__\\apu2sampler4xi5test.cpython-32.pyc'>
                                
            except:
                message2print = "{(Step 3Z9/33) failed" + "; file2input-failed-by-build2scope4xi: " + str(file2input) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)     
                #                 


        else:
            message2print = "{(Step 1E/33) skipped" + "; path2input-skipped-by-build2scope4xi: " + str(path2input)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                      
            # ..//..//..//..//scope4xi//041721//zap//lib//a//__pycache__\apu2buffer4xi.cpython-32.pyc
            
            count2skipped = count2skipped + 1
            count2total = count2total + 1

    else:
        message2print = "{(Step 1F/33) skipped" + "; name2program-skipped-by-build2scope4xi: " + str(name2program)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # 
        
        extension2skip = name2program[1]
        message2print = "{(Step 1G/33) skipped" + "; extension-skipped-by-build2scope4xi: " + str(extension2skip[1:])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 
        count2skipped = count2skipped + 1
        count2total = count2total + 1
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global count2skipped
    global count2found
    global count2total
    
    global path2read4xi
    global path2write4xi
    global profile2build

    global t2xi
    global trace_object_count    

       
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1A/33) OF MAIN FETCH2SCOPE4XI - SET T2XI TO: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
    
     
    count2skipped = 0
    count2found = 0
    count2total  = 0   

    set2trace4fecth()                                                                                               # trace all classes and functions in the system
    deny2trace4build()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    

    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print('=' *70)
    print("(Step 2A/33) OF MAIN FETCH2SCOPE4XI - VERSION 8.12 FOR ", path2read4xi, " WITH PROFILE: ", profile2build, " STARTED ", time4xi())
    # VERSION 8.12 FOR  ..//..//..//..//scope4xi//041721//zap//lib//  WITH PROFILE:  .pyc

    
    for dir2walk in DirectoryWalker(path2read4xi):
        # ----------------------------------------------------------------------------------------- 
        #
        # -----------------------------------------------------------------------------------------     
        dir2walk =  dir2walk + '//__pycache__'
        if os.path.isdir(dir2walk):
            print ("Directory: " + dir2walk + '\n')
            # Directory: ..//..//..//..//scope4xi//041721//zap//lib//a//__pycache__//
            # 
            for file2walk in DirectoryWalker(dir2walk):
                if os.path.isfile(file2walk):
                    build2scope4xi(file2walk)
            
    # --------------------------------------------------------------------------------------------- 
    # END
    # --------------------------------------------------------------------------------------------- 
    print('=' *75)
    print("(Step 3A/33) OF MAIN FETCH2SCOPE4XI - VERSION 8.12 FOR ", path2read4xi, " WITH PROFILE: ", profile2build, " COMPLETED  ", time4xi())
    # VERSION 8.12 FOR  ..//..//..//..//scope4xi//041721//zap//lib//  WITH PROFILE:  .pyc  COMPLETED   02:42:36 11/28/11 Pacific Standard Time
           
    # -------------------------------------------------------------------------------------------
    # STATISTICS
    # ------------------------------------------------------------------------------------------- 
    print ('(Step 4A/33) OF MAIN FETCH2SCOPE4XI - FOUND: ', count2found)
    print ('(Step 4B/33) OF MAIN FETCH2SCOPE4XI - SKIPPED: ', count2skipped)
    print ('(Step 4C/33) OF MAIN FETCH2SCOPE4XI - TOTAL: ', count2total)
    # FOUND:     26
    # SKIPPED:  279
    # =============
    # TOTAL:    305
    test2total = count2found + count2skipped
    if test2total == count2total:
        pass
    else:
        print ('(Step 4Z/33) OF MAIN FETCH2SCOPE4XI *** FAILED: FOUND + SKIPPED: ', test2total, " .NE. TOTAL: ", count2total, " ***")
        
    # ===========================================================================
    # 
    # 
    # ===========================================================================         
    print('=' *75)
    
    
     
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    print ('(Step 33A/33) OF MAIN FETCH2SCOPE4XI - PRINTING TRACE WITH T2XI', t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    print_trace4xi(t2xi)        
    print ('(Step 33B/33) OF MAIN FETCH2SCOPE4XI - PRINTED TRACE WITH T2XI', t2xi)           
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# L:\temp\txt\build2scope4xi.txt
# ROOT4XI\Studio4Xi\web\xml\ace-build2scope.xml
# ROOT4XI\Studio4Xi\web\xml\reason-build2scope.xml
# ROOT4XI\Studio4Xi\web\xml\sense-build2scope.xml
# 
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of build2scope4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

